from __future__ import absolute_import
from __future__ import print_function
import os, time, subprocess, sys, shutil, cribl

splunk_home = os.getenv("SPLUNK_HOME", "")
splunk_cmd = os.path.join(splunk_home, "bin","splunk")

#1. un/install our module if needed and restart
hasCriblModule = os.path.isfile(os.path.join(splunk_home, "etc", "modules", "cribl", "config.xml"))
isCriblDemo = os.path.isfile(os.path.join(splunk_home, "etc", "apps", "cribl", "demo.mode"))
needRestart = False

if not hasCriblModule and isCriblDemo:
  print("Installing Cribl module and restarting Splunk ...")
  shutil.copytree(os.path.join(splunk_home, "etc", "apps", "cribl", "modules", "cribl"), os.path.join(splunk_home, "etc", "modules", "cribl"))
  needRestart = True
elif hasCriblModule and not isCriblDemo:
  print("Uninstalling Cribl module and restarting Splunk ...")
  shutil.rmtree(os.path.join(splunk_home, "etc", "modules", "cribl"))
  needRestart = True

if needRestart:
  # restart splunk from a different background process ...
  res = subprocess.Popen([splunk_cmd, "restart", "-f"])
  time.sleep(1)
  sys.exit(0)

#2. now  start the server
cribl.runCriblCommand(['server'])